module Data.Serialize.Ldsf.Lean.Category (
      allFunctions
    , lookupFunction
    ) where

import Data.Map (Map)
import qualified Data.Map as Map
import qualified Data.Serialize.Ldsf as Ldsf
import  Data.Serialize.Ldsf.Lean.InterfaceFunction (InterfaceFunction(InterfaceFunction))
import qualified Data.Serialize.Ldsf.Lean.Category.Browser.V0 as BrowserV0
import qualified Data.Serialize.Ldsf.Lean.Category.Text.V0 as TextV0
import Network.Lean.Types

allFunctions :: Map (Ldsf.Version, InterfaceCategory, InterfaceVersion, InterfaceFunctionId) InterfaceFunction
allFunctions =
    Map.unions
        [ BrowserV0.lookupTable
        , TextV0.lookupTable
        ]

lookupFunction :: Ldsf.Version -> InterfaceCategory -> InterfaceVersion -> InterfaceFunctionId -> Maybe InterfaceFunction
lookupFunction ldsfVer cat ver fId = Map.lookup (ldsfVer, cat, ver, fId) allFunctions
