module Data.Serialize.Ldsf.Lean.Category.Text.V0 (
      category
    , version
    , functionGet
    , lookupTable
    ) where

import Data.Map (Map)
import qualified Data.Map as Map
--import Data.Serialize.Get (Get)
--import Data.Serialize.Put (Putter)
import Data.Serialize.Ldsf (getText8, getText32)
import qualified Data.Serialize.Ldsf as Ldsf
import Data.Serialize.Ldsf.Types
import Data.Serialize.Ldsf.Lean.InterfaceFunction (InterfaceFunction(InterfaceFunction))
import qualified Data.Serialize.Ldsf.Lean.InterfaceFunction as IF
import qualified Data.Text as T
import Network.Lean.Types

ldsfVersion :: Ldsf.Version
ldsfVersion = 0

category :: InterfaceCategory
category = Text

version :: InterfaceVersion
version = 0

functionGet :: InterfaceFunction
functionGet = InterfaceFunction
    { IF.id = 0
    , IF.ldsfVersion = ldsfVersion
    , IF.category = category
    , IF.version = version
    , IF.name = T.pack "get"
    , IF.getArgs = getArgs
    , IF.putArgs = putArgs
    , IF.getResult = getResult
    , IF.putResult = putResult
    }
    where
        getArgs = getText8 >>= \v -> pure [ValueText8 v]
        putArgs [ValueText8 v] = [ValueText8 v]
        putArgs _              = fail "Expected type ValueText8" -- TODO: is fail good!?!?
        getResult = getText32 >>= \v -> pure [ValueText32 v]
        putResult [ValueText32 v] = [ValueText32 v]
        putResult _               = fail "Expected type ValueText32" -- TODO: is fail good!?!?

lookupTable :: Map (Ldsf.Version, InterfaceCategory, InterfaceVersion, InterfaceFunctionId) InterfaceFunction
lookupTable = makeLookupTable
    [ functionGet
    ]

makeLookupEntry :: InterfaceFunction -> ((Ldsf.Version, InterfaceCategory, InterfaceVersion, InterfaceFunctionId), InterfaceFunction)
makeLookupEntry x = ((IF.ldsfVersion x, IF.category x, IF.version x, IF.id x), x)

makeLookupTable :: [InterfaceFunction] -> Map (Ldsf.Version, InterfaceCategory, InterfaceVersion, InterfaceFunctionId) InterfaceFunction
makeLookupTable xs = Map.fromList $ map makeLookupEntry xs
