module Data.Serialize.Ldsf.Types (
      UInt8
    , UInt16
    , UInt32
    , UInt64
    , Int8
    , Int16
    , Int32
    , Int64
    , Float32
    , Float64
    , Text8(..)
    , Text16(..)
    , Text32(..)
    , Text64(..)
    , ByteString8(..)
    , ByteString16(..)
    , ByteString32(..)
    , ByteString64(..)
    , Value(..)
    ) where

import Data.ByteString (ByteString)
import qualified Data.ByteString.Lazy as BL
import qualified Data.Int as I
import Data.Text (Text)
import qualified Data.Text.Lazy as TL
import Data.Word (Word8, Word16, Word32, Word64)

type UInt8 = Word8
type UInt16 = Word16
type UInt32 = Word32
type UInt64 = Word64
type Int8 = I.Int8
type Int16 = I.Int16
type Int32 = I.Int32
type Int64 = I.Int64
type Float32 = Float
type Float64 = Double
type Text8 = Text
type Text16 = Text
type Text32 = TL.Text
type Text64 = TL.Text
type ByteString8 = ByteString
type ByteString16 = ByteString
type ByteString32 = BL.ByteString
type ByteString64 = BL.ByteString

-- | An LDSF value represented as a Haskell value.
data Value = ValueNothing
           | ValueUInt8 UInt8
           | ValueUInt16 UInt16
           | ValueUInt32 UInt32
           | ValueUInt64 UInt64
           | ValueInt8 Int8
           | ValueInt16 Int16
           | ValueInt32 Int32
           | ValueInt64 Int64
           | ValueFloat32 Float32
           | ValueFloat64 Float64
           | ValueText8 Text8
           | ValueText16 Text16
           | ValueText32 Text32
           | ValueText64 Text64
           | ValueByteString8 ByteString8
           | ValueByteString16 ByteString16
           | ValueByteString32 ByteString32
           | ValueByteString64 ByteString64
           deriving (Eq, Ord, Show)
