module Main where

import qualified Data.ByteString as B
import Data.Serialize.Ldsf.Types
import qualified Data.Serialize.Ldsf.Lean.InterfaceFunction as IF
import qualified Data.Serialize.Ldsf.Lean.Category.Browser.V0 as BrowserV0
import qualified Data.Serialize.Ldsf.Lean.Category.Text.V0 as TextV0
import qualified Data.Text as T
import Network.Lean.Client
import Network.Lean.Types

import Data.Serialize.Ldsf.Lean

main :: IO ()
main = do
    let f0 = BrowserV0.functionConnect
        req0 = Request
            { requestHostname = T.pack "crowbar.i2p"
            , requestCategory = IF.category f0
            , requestVersion = IF.version f0
            , requestFunction = IF.id f0
            , requestArguments = IF.putArgs f0 [ValueText8 $ T.pack "crowbar.i2p"]
            , requestInternal = Nothing
            } :: ClientRequest
        getResult0 =  IF.getResult f0
        
        f1 = TextV0.functionGet
        req1 = Request
            { requestHostname = T.pack "crowbar.i2p"
            , requestCategory = IF.category f1
            , requestVersion = IF.version f1
            , requestFunction = IF.id f1
            , requestArguments = IF.putArgs f1 [ValueText8 $ T.pack "index"]
            , requestInternal = Nothing
            } :: ClientRequest
        getResult1 = IF.getResult f1
            -- use request to determine: category, version and function

    _ <- withClient "127.0.0.1" "9911" $ \client -> do
        putStrLn $ "sent request: " ++ show req0
        maybeResponse <- request client req0 getResult0
        case maybeResponse of
             Nothing     -> fail "Failed on first request!"
             Just (h, r) -> do
                 putStrLn $ "server responded: " ++ show r
        
        putStrLn $ "sent request: " ++ show req1
        maybeResponse <- request client req1 getResult1
        case maybeResponse of
            Nothing     -> fail "Failed on second request!"
            Just (h, r) -> do
                putStrLn $ "server responded: " ++ show r
                pure Nothing
    
    pure ()
